/*
    FEARLUS model0-7-1ci: Interval.h
    Copyright (C) 1999-2003, 2006  Macaulay Institute

    This file is part of FEARLUS model0-7-1ci, an agent-based model of land use
    change.

    FEARLUS model0-7-1ci is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    FEARLUS model0-7-1ci is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/


#import <objectbase/SwarmObject.h>
#import <stdio.h>

@interface Interval : SwarmObject {
  double min;
  double max;
  @public
  double var;
}

+(unsigned long)stackSize;
+(unsigned long)intervalCount;
+getZone;

+constant: (double)value;
+castInt: (int)value;
+castULL: (unsigned long long)value;
+create;
+createWith: (double)value;
+createWith: (double)value min: (double)lo max: (double)hi;
-clone;

-bufread: (FILE *)fp;
-bufwrite;
-bufwrite: (FILE *)fp;
-bufwrite: (FILE *)fp format: (char *)format;
-(void)print;
-(void)print: (char *)format;
-(char *)printf: (char *)format;
-(char *)printfVar: (char *)format;
-(char *)printfRange: (char *)format;
+(void)printfclean;
-strread: (char *)buffer;
-(int)strwrite: (char *)buffer size: (size_t)bufsz;
-(int)strwriteVar: (char *)buffer size: (size_t)bufsz;
-(int)strwriteRange: (char *)buffer size: (size_t)bufsz;
-(int)strwrite: (char *)buffer size: (size_t)bufsz format: (char *)format;
-(int)strwriteVar: (char *)buffer size: (size_t)bufsz format: (char *)format;
-(int)strwriteRange: (char *)buffer size: (size_t)bufsz format: (char *)format;
-read: (int)fildes;
-write: (int)fildes;

-set: (Interval *)value;
-get: (double *)varptr min: (double *)minptr max: (double *)maxptr;
-(double)getVar;
-(double)getMin;
-(double)getMax;

-add: (Interval *)value;
-sum: (Interval *)value;
-inc;

-sub: (Interval *)value;
-diff: (Interval *)value;
-dec;

-mul: (Interval *)value;
-prod: (Interval *)value;

-div: (Interval *)value;
-quot: (Interval *)value;

-neg;

-(BOOL)eq: (Interval *)value;
-(BOOL)ne: (Interval *)value;
-(BOOL)gt: (Interval *)value;
-(BOOL)le: (Interval *)value;
-(BOOL)lt: (Interval *)value;
-(BOOL)ge: (Interval *)value;

-(BOOL)Meq: (Interval *)value;
-(BOOL)Mne: (Interval *)value;
-(BOOL)Mgt: (Interval *)value;
-(BOOL)Mle: (Interval *)value;
-(BOOL)Mlt: (Interval *)value;
-(BOOL)Mge: (Interval *)value;

-(BOOL)Leq: (Interval *)value;
-(BOOL)Lne: (Interval *)value;
-(BOOL)Lgt: (Interval *)value;
-(BOOL)Lle: (Interval *)value;
-(BOOL)Llt: (Interval *)value;
-(BOOL)Lge: (Interval *)value;

-ret;
-call;
-fumble;
-(void)drop;

-(double)gap;

@end
